
Option Explicit
On Error Resume Next
'-----------------------------
' Constants
'-----------------------------
Const cLogFile = "RPCHTTP.log"
Const ForAppending = 8
Const TemporaryFolder = 2
Const cTitle = "The Message Center RPC over HTTPS" 
Const cErrorTitle = "Required Software Missing" 

Const Off11FamilyCode = "{????????-6000-11D3-8CFE-0?50048383C9}"
Const cValidationMsg = "Invalid Outlook 2007 Login (MAPI profile). RPC over HTTP could not be configured."
'-----------------------------
' Objects
'-----------------------------
Dim WshShell : Set WshShell = CreateObject("Wscript.Shell")
Dim fso : Set fso = CreateObject("Scripting.FileSystemObject")
Dim msi : Set msi = CreateObject("WindowsInstaller.Installer")

'-----------------------------
' Path Variables
'-----------------------------
Dim root : root = fso.GetParentFolderName(Wscript.ScriptFullName)
Dim	sUserProfile : sUserProfile = wshShell.ExpandEnvironmentStrings("%USERPROFILE%")
Dim sTemp : sTemp = fso.GetSpecialFolder(TemporaryFolder)
Dim sTempPRFFile : sTempPRFFile = sTemp & "\" & fso.GetTempName


Dim sLogFile : sLogFile = fso.BuildPath(sTemp,cLogFile)
Dim srcPRFFile : srcPRFFile = ""
Dim dstPRFFile : dstPRFFile = ""


Dim output : output = ""

Dim sExgSrvr : sExgSrvr = ""
Dim errors : errors = ""
'-----------------------------
' Booleans
'-----------------------------
Dim bNeedsReboot : bNeedsReboot = FALSE
Dim bDebug : bDebug = FALSE
Dim bManual : bManual = TRUE
Dim bOffice11Installed :  bOffice11Installed = FALSE
'-----------------------------
' Operating System Variables
'-----------------------------
Dim osVer,osCSDVer,osBuild,osSPMaj,osSPMin,osLanguage

'-----------------------------
' Exchange Servers-PRF Files
'-----------------------------
Const StandardTopologies = 2

CreateLog
WriteLog "Root: " & root
WriteLog "Temporary Directory: " & sTemp
WriteLog "UserProfile: " & sUserProfile

'Make sure we can run the script on this machine
'bOffice11Installed = IsOffice11Installed()
'If Not bOffice11Installed then
'	WriteLog "Office 2007 Professional is not Installed."
'	wshShell.Popup "RPC over HTTP requires Office 2007 Beta 2 or later to be installed.",0,cErrorTitle
'	EndScript 1050
'End If
'DetectOS
'If (osVer < "5.1") OR ( (osVer = "5.1") AND (osSPMaj < 1)) Then
'	WriteLog "Operating System does not support RPC over HTTP."
'	wshShell.Popup "You must install Windows XP SP1 before you can use this MAPI profile creation tool.",0,cErrorTitle
'	EndScript 1012
'End If
'If ( (osVer = "5.1") AND (osSPMaj = 1) AND (osLanguage <> 1033) ) Then
'	WriteLog "Operating System does not support RPC over HTTP."
'	wshShell.Popup "You must install Windows XP SP1 before you can use this MAPI profile creation tool.",0,cErrorTitle
'	EndScript 1012
'End If

'After we know that ths script should be able to run, notify the user of the pre-requisites
Dim popret : popret = 0
popret = WshShell.Popup("This script will add a RPC/HTTPS MAPI profile to your machine.  Would you like to continue?",0,cTitle,4)
If popret = 7 Then
	EndScript 0
End If

srcPRFFile = sTempPRFFile
GenerateDynamicPRF_File(srcPRFFile)
WriteLog "file done " + srcPRFFile
If  ((sTempPRFFile <> "") AND fso.FileExists(srcPRFFile)) Then
	WriteLog "Inside"
	EnableUI 
	WriteLog "ImportPRF"
	ImportPRF
	WriteLog "RemoveFristRun"
	RemoveFirstRun
	SetSRSIncrementalLimit
	SetOABLimit
	SetSRSFullLimit
	SetOABAllow
	WriteLog "FinishDialog"
	FinishDialog
	WriteLog "EndScript 0"
	EndScript 0
Else
	If sExgSrvr <> "" Then
		wshShell.Popup "RPC over HTTP has not yet been setup for users on the " & sExgSrvr & " Mail Server.",0,cTitle
	Else
		wshshell.Popup "Your Outlook Profile has not been configured yet. Run Outlook and exit out prior to rerunning this script.",0,cTitle
	End If
	EndScript 1010 'Machine Excluded (Due to Exchange Server)
End If




Sub EnableUI() 'EnableUI
	Dim retVal
	retVal = WriteRegistry("HKCU\Software\Microsoft\Office\12.0\Outlook\RPC\EnableRPCtunnelingUI","REG_DWORD",1)
End Sub


Sub SetLMCompat() 'LMCompatibilityLevel = 2
	Dim retVal
	retVal = WriteRegistry("HKLM\SYSTEM\CurrentControlSet\Control\Lsa\LMCompatibilityLevel","REG_DWORD",2)
End Sub

Sub ImportPRF() 'Set up the Import
	If fso.FileExists(srcPRFFile) Then
		bManual = Not WriteRegistry("HKCU\Software\Microsoft\Office\12.0\Outlook\Setup\ImportPRF","REG_SZ",srcPRFFile)
	Else
		bManual = TRUE
		WriteLog "File [" & srcPRFFile & "] doesn't exist.	Not Setting ImportPRF"
	End If
End Sub

Sub RemoveFirstRun() 'Remove First Run
	bManual = Not DeleteRegistry("HKCU\Software\Microsoft\Office\12.0\Outlook\Setup\First-Run")
End Sub

Sub FinishDialog() 'Cause Reboot
	'On Error Resume Next
	Dim popret : popret = 0
	Dim spopMsg
	If Not bManual Then
		If bNeedsReboot Then
			popret = WshShell.Popup("To complete the configuration of RPC over HTTP, please reboot your machine.  Would you like to reboot now?",0,cTitle,4)
			If popret=6 Then
				doReboot
			End If
		Else
			popret = WshShell.Popup("To complete the configuration of RPC over HTTP, please exit and restart Outlook if it's running",0,cTitle)
		End If
	Else
		If bNeedsReboot Then
			sPopMsg = "To complete the installation of RPC over HTTP, please reboot your machine.  Then goto "
			sPopMsg = sPopMsg & fso.GetParentFolderName(dstPRFFile) & " and double click on the rpchttp.prf file."
			sPopMsg = sPopMsg & vbcrlf & "Do you wish to reboot Now?"
			popret=WshShell.Popup(sPopMsg,0,cTitle,4)
			If popret=6 Then
				doreboot
			End If
		Else
			sPopMsg = "To complete the installation of RPC over HTTP, please goto "
			sPopMsg = sPopMsg & fso.GetParentFolderName(dstPRFFile) & " and double click on the rpchttp.prf file."
			popret=WshShell.Popup(sPopMsg,0,cTitle)
		End If
	End If
End Sub
		 
Sub WriteLog(strMessage)
	On Error Resume Next
	If IsObject(output) Then
		output.WriteLine Now & ": " & strMessage
	End If
	If bDebug Then wscript.echo strMessage
End Sub

Sub CreateLog()
	On Error Resume Next
	If Not IsObject(output) Then
		If fso.FileExists(sLogFile) Then
			set output = fso.OpenTextFile(slogFile,ForAppEnding,True)
		Else
			set output = fso.CreateTextFile(slogfile)
		End If
		If Err <> 0 Then
			output = ""
		Else
			WriteLog "--- Logging Started ---"
			WriteLog "LogFile: " & sLogFile 
		End If
	End If
End Sub



Function GenerateDynamicPRF_File(PRFFilePath)
		On Error resume next
		If Err <> 0 Then
			WshShell.Popup "Cannot write in temp directory." & "RPC over HTTP could not be configured.",0,cTitle
			EndScript 1603
		Else
			
			Dim sLoginAccount : sLoginAccount = Trim(InputBox("Please enter your Outlook 2007 Login (your email address): ." + vbNewLine + "Example: jdoe@domain.com" ,"Enter login account",""))
			' Dim sCustomerExchangeServer : sCustomerExchangeServer = Trim(InputBox("Please enter your Exchange Server (included in your setup email): ." + vbNewLine + "Example: ex-be-001-sfo.shared.themessagecenter.com",""))
			' Should add in an item to ask for the back-end Exchange server the customer is on.  We would need to include this in 
			' the setup letter. 
			
				
			'Validate user input (login account).
			'	1 - If any error then exit w msg
			'   2 -		If empty then exit w/o msg 
			'	3 -		If cannot find a '.' then exit w msg
			'	4 -		If a backlash is found then take out the domain from login.
			If Err <> 0 then  
					WshShell.Popup cValidationMsg,0,cTitle
					EndScript 1603
			Else
				If Trim("" & sLoginAccount) = "" Then ' Cancel - Exit
					WriteLog "Exit Cancel"
					EndScript 0
				End if
				If Not (InStr(1,sLoginAccount,".") > 0) Then
					WshShell.Popup cValidationMsg ,0,cTitle
					EndScript 1603
				End if
				Dim lenBackSlash : lenBackSlash = (InStr(1,sLoginAccount,"\") )
				If lenBackSlash > 0 Then
					If Len(sLoginAccount) > lenBackSlash then
						'Strip out the domain from sLoginAccount.
						WriteLog sLoginAccount
						sLoginAccount = Mid(sLoginAccount,lenBackSlash + 1,Len(sLoginAccount) - lenBackSlash)
						WriteLog sLoginAccount
					Else
						WshShell.Popup cValidationMsg,0,cTitle
						EndScript 1603
					End if
				End if
			End If
			WriteLog "End validation login"
			'--------------------------------------------------------------------
			Dim PRF_File : PRF_File = ""
			set PRF_File = fso.CreateTextFile(PRFFilePath)
					
			PRF_File.WriteLine ";Automatically generated PRF file from the Microsoft Office Customization and Installation Wizard" 
			PRF_File.WriteLine ";for use with the Exchange RPC over HTTP trial service" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "; **************************************************************" 
			PRF_File.WriteLine "; Section 1 - Profile Defaults" 
			PRF_File.WriteLine "; **************************************************************" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[General]" 
			PRF_File.WriteLine "Custom=1" 
			PRF_File.WriteLine "ProfileName=" + sLoginAccount
			PRF_File.WriteLine "DefaultProfile=Yes" 
			PRF_File.WriteLine "OverwriteProfile=Yes" 
			PRF_File.WriteLine "ModifyDefaultProfileIfPresent=FALSE" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "; **************************************************************" 
			PRF_File.WriteLine "; Section 2 - Services in Profile" 
			PRF_File.WriteLine "; **************************************************************" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[Service List]" 
			PRF_File.WriteLine "ServiceX=Microsoft Outlook Client" 
			PRF_File.WriteLine "ServiceEGS=Exchange Global Section" 
			PRF_File.WriteLine "Service1=Microsoft Exchange Server" 
			PRF_File.WriteLine "ServiceEGS=Exchange Global Section" 
			PRF_File.WriteLine "Service2=Outlook Address Book" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine ";***************************************************************" 
			PRF_File.WriteLine "; Section 3 - List of internet accounts" 
			PRF_File.WriteLine ";***************************************************************" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[Internet Account List]" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine ";***************************************************************" 
			PRF_File.WriteLine "; Section 4 - Default values for each service." 
			PRF_File.WriteLine ";***************************************************************" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[ServiceX]" 
			PRF_File.WriteLine "CachedExchangeMode=0x00000002" 
			PRF_File.WriteLine "CachedExchangeSlowDetect=TRUE" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[ServiceEGS]" 
			PRF_File.WriteLine "CachedExchangeConfigFlags=0x00000100" 
			'PRF_File.WriteLine "MailboxName=" + sCustomerExchangeServer
			PRF_File.WriteLine "MailboxName=" + sLoginAccount
		  PRF_File.WriteLine "HomeServer=ex-be-001-sfo.shared.themessagecenter.com" 
			'PRF_File.WriteLine "HomeServer="  
			PRF_File.WriteLine "RPCoverHTTPflags=0x002b" 
			PRF_File.WriteLine "RPCProxyServer=mail.themessagecenter.com" 
			PRF_File.WriteLine "RPCProxyPrincipalName=" 
			PRF_File.WriteLine "RPCProxyAuthScheme=0x0001" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[Service1]" 
			PRF_File.WriteLine "OverwriteExistingService=No" 
			PRF_File.WriteLine "UniqueService=Yes" 
			' Needs to be user@domain.com
			PRF_File.WriteLine "MailboxName=" + sLoginAccount
			PRF_File.WriteLine "HomeServer=ex-be-001-sfo.shared.themessagecenter.com" 
			'PRF_File.WriteLine "HomeServer=" + sCustomerExchangeServer
			PRF_File.WriteLine "AccountName=Microsoft Exchange Server" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[Service2]" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine ";***************************************************************" 
			PRF_File.WriteLine "; Section 5 - Values for each internet account." 
			PRF_File.WriteLine ";***************************************************************" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine ";***************************************************************" 
			PRF_File.WriteLine "; Section 6 - Mapping for profile properties" 
			PRF_File.WriteLine ";***************************************************************" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[Microsoft Exchange Server]" 
			PRF_File.WriteLine "ServiceName=MSEMS" 
			PRF_File.WriteLine "MDBGUID=5494A1C0297F101BA58708002B2A2517" 
			PRF_File.WriteLine "MailboxName=PT_STRING8,0x6607" 
			PRF_File.WriteLine "HomeServer=PT_STRING8,0x6608" 
			PRF_File.WriteLine "OfflineAddressBookPath=PT_STRING8,0x660E" 
			PRF_File.WriteLine "OfflineFolderPath=PT_STRING8,0x6610" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[Exchange Global Section]" 
			PRF_File.WriteLine "SectionGUID=13dbb0c8aa05101a9bb000aa002fc45a" 
			PRF_File.WriteLine "MailboxName=PT_STRING8,0x6607" 
			PRF_File.WriteLine "HomeServer=PT_STRING8,0x6608" 
			PRF_File.WriteLine "RPCoverHTTPflags=PT_LONG,0x6623" 
			PRF_File.WriteLine "RPCProxyServer=PT_UNICODE,0x6622" 
			PRF_File.WriteLine "RPCProxyPrincipalName=PT_UNICODE,0x6625" 
			PRF_File.WriteLine "RPCProxyAuthScheme=PT_LONG,0x6627" 
			PRF_File.WriteLine "CachedExchangeConfigFlags=PT_LONG,0x6629" 
			PRF_File.WriteLine "HTTPExchangePort=PT_I2,0x662d" 
			PRF_File.WriteLine "HTTPReferralPort=PT_I2,0x6631" 
			PRF_File.WriteLine "HTTPDirectoryPort=PT_I2,0x662f" 
			PRF_File.WriteLine "TCPExchangePort=PT_I2,0x662c" 
			PRF_File.WriteLine "TCPReferralPort=PT_I2,0x6630" 
			PRF_File.WriteLine "TCPDirectoryPort=PT_I2,0x662e" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[Outlook Address Book]" 
			PRF_File.WriteLine "ServiceName=CONTAB" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "[Microsoft Outlook Client]" 
			PRF_File.WriteLine "SectionGUID=0a0d020000000000c000000000000046" 
			PRF_File.WriteLine "CachedExchangeMode=PT_LONG,0x041f" 	
			PRF_File.WriteLine "CachedExchangeSlowDetect=PT_BOOLEAN,0x0420" 
			PRF_File.WriteLine "" 
			PRF_File.WriteLine "; ************************************************************************" 
			PRF_File.WriteLine "; Section 7 - Mapping for internet account properties." 
			PRF_File.WriteLine "; ************************************************************************" 
			PRF_File.close
		End If
	
End Function





Sub EndScript(retcode)
	On Error Resume Next
	WriteLog "--- Logging Complete ---"
	WriteLog ""
	StatusMIF "",1
	If isObject(output) Then output.close
	wscript.quit(retcode)
End Sub

Sub StatusMIF(strMsg,statusCode)
End Sub

Function QFE_IsInstalled(sQFE)
	On Error Resume Next
	Dim IsInstalled : IsInstalled = 0
	Dim QFEReg : QFEReg = "HKLM\Software\Microsoft\Windows NT\CurrentVersion\Hotfix"
	Dim sQFERegPath : sQFERegPath = QFEReg & "\" & sQFE & "\Installed"
	QFE_IsInstalled=FALSE
	IsInstalled = wshshell.RegRead(sQFERegPath)
	If Err <> 0 Then
		WriteLog Err & ":" & Err.Description
		If CBool(IsInstalled) Then
			WriteLog "QFE " & sQFE & " is Installed."
			QFE_IsInstalled = TRUE
		Else
			WriteLog "QFE " & sQFE & " is not Installed."
			QFE_IsInstalled = FALSE
		End If
	Else
		WriteLog IsInstalled & " < "  & sQFERegPath
		WriteLog "QFE " & sQFE & " is Installed."
		QFE_IsInstalled = TRUE
	End If
End Function

Function doReboot()
	Dim oSvc,eOS,oOS
	WriteLog "--- Logging Complete ---"
	WriteLog ""
	StatusMIF "",1
	If isObject(output) Then 
		output.close
		Set output = Nothing
		output = ""
	End If
	On Error Resume Next
	Set oSvc = GetObject("winmgmts:{impersonationLevel=impersonate,(Shutdown)}root/cimv2")
	Set eOS = oSvc.ExecQuery("Select * from Win32_OperatingSystem")
	For Each oOS in eOS
		oOS.Reboot()
	Next 
	If Err <> 0 Then
		wshShell.Popup "Your machine could not be rebooted.  Please reboot at your earliest convenience.",0,cTitle,0
	End If
End Function

Function DetectOS()
	On Error Resume Next
	Dim oSvc,eOS,oOS
	Set oSvc = GetObject("winmgmts:{impersonationLevel=impersonate}root/cimv2")
	Set eOS = oSvc.ExecQuery("Select * from Win32_OperatingSystem")
	For Each oOS in eOS
		osVer = oOS.Version
		If Len(osVer) >= 3 Then osVer=Left(osVer,3)
		WriteLog "Operating System Version: " & osVer
		osBuild = oOS.BuildNumber
		WriteLog "Operating System Build: " & osBuild
		osCSDVer = oOS.CSDVersion
		osSPMaj = oOS.ServicePackMajorVersion
		WriteLog "Operating System SP: " & osSPMaj
		osSPMin = oOS.ServicePackMinorVersion
		WriteLog "Operating System Minor SP: " & osSPMin
		osLanguage = oOS.OSLanguage
		WriteLog "Operating System Language: " & osLanguage
	Next 
End Function

'----------------------------------------------------------------
'Function CheckProductCode
'  Returns: TRUE if ProductCode Matches the CodeTemplate
'           FALSE Otherwise
'  Where CodeTemplate is in the format of
'  {????????-XXXX-XXXX-XXXX-XXXXXXXXXXXXX} 
'    where a '?' designates a wildcard, and the 'X' represents a
'    Hexadecimal Digit
'----------------------------------------------------------------
Function CheckProductCode(ProductCode,CodeTemplate)
	Dim Count, bNoMatch, i
	if bDebug Then wscript.echo ProductCode & "---" &CodeTemplate
	CheckProductCode = FALSE
	Count = len(CodeTemplate)
	If len(ProductCode) = Count Then
		bNoMatch = FALSE
		for i = 1 to Count
		
		If Not bNoMatch Then
		'	If bDebug Then wscript.echo mid(CodeTemplate,i,1) &  " - = - " & mid(ProductCode,i,1)
			If mid(CodeTemplate,i,1) <> "?" Then
				If mid(CodeTemplate,i,1) <> mid(ProductCode,i,1) Then
					'If bDebug Then wscript.echo "No Match at " & i
					bNoMatch = TRUE
				End If
			End If
		End If
		next
		If Not bNoMatch Then CheckProductCode = TRUE
	End If
End Function

'----------------------------------------------------------------
'Function IsOffice11Installed
'	Returns TRUE if product code of Off11FamilyCode exists
'	Returns FALSE if Office 11 MSI product code not found
'----------------------------------------------------------------
Function IsOffice11Installed()
	IsOffice11Installed = FALSE
	Dim eProds,oProd
	Set eProds = msi.Products
	For Each oProd in eProds
		If CheckProductCode(oprod,Off11FamilyCode) Then 
			IsOffice11Installed = TRUE
			Exit For
		End If
	Next
End Function

'----------------------------------------------------------------
'Function WriteRegistry
'	Returns TRUE if registry value was written successfully
'	Returns FALSE on error and logs
'----------------------------------------------------------------
Function WriteRegistry(regVal,regType,regData)
	WriteRegistry = TRUE
	On Error Resume Next
	Dim regEntry
	regEntry = wshShell.RegRead(regVal)
	If Err = 0 Then
		WriteLog "[" & regEntry & "]" & " < " & regVal
	Else
		WriteLog "[] < " & regVal
	End If
	Err.Clear
	wshShell.RegWrite regVal,regData,regType
	regEntry = wshShell.RegRead(regVal)
	If Err = 0 Then
		WriteLog "[" & regEntry & "]"  & " > " & regVal
	Else
		WriteRegistry = FALSE
		WriteLog "Error: " & Err & ":" & Err.Description
		WriteLog "[] > " & regVal
	End If
	Err.Clear
End Function

'----------------------------------------------------------------
'Function DeleteRegistry
'	Returns TRUE if registry value was deleted successfully
'	Returns FALSE on error and logs
'----------------------------------------------------------------
Function DeleteRegistry(regVal)
	DeleteRegistry = TRUE
	On Error Resume Next
	Dim regEntry
	wshShell.RegDelete regVal
	If Err <> 0 Then
		If Err = &H80070002 Then
			WriteLog "Registry " & regVal & " was not Present."
		End If
	End If
	regEntry = wshShell.RegRead(regVal)
	If regEntry <> "" Then DeleteRegistry = FALSE
	Err.Clear
End Function

